=== debian/changelog ===
csound (1:6.09.0~dfsg-1) unstable; urgency=medium

  * New upstream version
    - Refresh patches
    - Install new header file csound_threaded.hpp
    - Add new symbols introduced in this version
    - Update cmake options for new version
  * Build and run tests.
    But don't install the static library
  * Remove boost dependencies, no longer needed.
    They were replaced with eigen
  * Fix cleanup of doxygen autogenerated files
  * Enable hardening features
  * Use dh_missing instead of --fail-missing flag to dh_install

 -- Felipe Sateler <fsateler@debian.org>  Tue, 20 Jun 2017 21:15:25 -0400
